using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BG_UHD_44M
{
    public class UserModuleClass_BG_UHD_44M : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        
        Crestron.Logos.SplusObjects.StringInput RX_MATRIX;
        Crestron.Logos.SplusObjects.DigitalInput LOGIN_DRIVER;
        Crestron.Logos.SplusObjects.DigitalInput POWER_ON;
        Crestron.Logos.SplusObjects.DigitalInput POWER_OFF;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> STORE_PRESET;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> RECALL_PRESET;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> OUTPUT;
        Crestron.Logos.SplusObjects.StringOutput TX_MATRIX;
        StringParameter USERNAME;
        StringParameter PASSWORD;
        object LOGIN_DRIVER_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 161;
                MakeString ( TX_MATRIX , "{0}\r\n{1}\r\n", USERNAME , PASSWORD ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object POWER_ON_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 168;
            TX_MATRIX  .UpdateValue ( "PON\r\n"  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object POWER_OFF_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 173;
        TX_MATRIX  .UpdateValue ( "POFF\r\n"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object STORE_PRESET_OnChange_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort LASTNUM = 0;
        
        
        __context__.SourceCodeLine = 188;
        LASTNUM = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 189;
        MakeString ( TX_MATRIX , "SMAP{0:d}\r\n", (short)LASTNUM) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RECALL_PRESET_OnChange_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort LASTNUM = 0;
        
        
        __context__.SourceCodeLine = 197;
        LASTNUM = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 198;
        MakeString ( TX_MATRIX , "LMAP{0:d}\r\n", (short)LASTNUM) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_OnChange_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort LASTNUM = 0;
        
        CrestronString SINPUT;
        CrestronString SOUTPUT;
        SINPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        SOUTPUT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 206;
        LASTNUM = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 207;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( LASTNUM < 10 ))  ) ) 
            {
            __context__.SourceCodeLine = 207;
            SOUTPUT  .UpdateValue ( "0" + Functions.ItoA (  (int) ( LASTNUM ) )  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 208;
            SOUTPUT  .UpdateValue ( Functions.ItoA (  (int) ( LASTNUM ) )  ) ; 
            }
        
        __context__.SourceCodeLine = 209;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( OUTPUT[ LASTNUM ] .UshortValue < 10 ))  ) ) 
            {
            __context__.SourceCodeLine = 209;
            SINPUT  .UpdateValue ( "0" + Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
            }
        
        else 
            {
            __context__.SourceCodeLine = 210;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (OUTPUT[ LASTNUM ] .UshortValue == 99))  ) ) 
                {
                __context__.SourceCodeLine = 210;
                SINPUT  .UpdateValue ( "00"  ) ; 
                }
            
            else 
                {
                __context__.SourceCodeLine = 211;
                SINPUT  .UpdateValue ( Functions.ItoA (  (int) ( OUTPUT[ LASTNUM ] .UshortValue ) )  ) ; 
                }
            
            }
        
        __context__.SourceCodeLine = 212;
        MakeString ( TX_MATRIX , "P{0}I{1}\r\n", SOUTPUT , SINPUT ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}


public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    
    LOGIN_DRIVER = new Crestron.Logos.SplusObjects.DigitalInput( LOGIN_DRIVER__DigitalInput__, this );
    m_DigitalInputList.Add( LOGIN_DRIVER__DigitalInput__, LOGIN_DRIVER );
    
    POWER_ON = new Crestron.Logos.SplusObjects.DigitalInput( POWER_ON__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_ON__DigitalInput__, POWER_ON );
    
    POWER_OFF = new Crestron.Logos.SplusObjects.DigitalInput( POWER_OFF__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_OFF__DigitalInput__, POWER_OFF );
    
    STORE_PRESET = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        STORE_PRESET[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( STORE_PRESET__DigitalInput__ + i, STORE_PRESET__DigitalInput__, this );
        m_DigitalInputList.Add( STORE_PRESET__DigitalInput__ + i, STORE_PRESET[i+1] );
    }
    
    RECALL_PRESET = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        RECALL_PRESET[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( RECALL_PRESET__DigitalInput__ + i, RECALL_PRESET__DigitalInput__, this );
        m_DigitalInputList.Add( RECALL_PRESET__DigitalInput__ + i, RECALL_PRESET[i+1] );
    }
    
    OUTPUT = new InOutArray<AnalogInput>( 4, this );
    for( uint i = 0; i < 4; i++ )
    {
        OUTPUT[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( OUTPUT__AnalogSerialInput__ + i, OUTPUT__AnalogSerialInput__, this );
        m_AnalogInputList.Add( OUTPUT__AnalogSerialInput__ + i, OUTPUT[i+1] );
    }
    
    RX_MATRIX = new Crestron.Logos.SplusObjects.StringInput( RX_MATRIX__AnalogSerialInput__, 255, this );
    m_StringInputList.Add( RX_MATRIX__AnalogSerialInput__, RX_MATRIX );
    
    TX_MATRIX = new Crestron.Logos.SplusObjects.StringOutput( TX_MATRIX__AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX_MATRIX__AnalogSerialOutput__, TX_MATRIX );
    
    USERNAME = new StringParameter( USERNAME__Parameter__, this );
    m_ParameterList.Add( USERNAME__Parameter__, USERNAME );
    
    PASSWORD = new StringParameter( PASSWORD__Parameter__, this );
    m_ParameterList.Add( PASSWORD__Parameter__, PASSWORD );
    
    
    LOGIN_DRIVER.OnDigitalPush.Add( new InputChangeHandlerWrapper( LOGIN_DRIVER_OnPush_0, false ) );
    POWER_ON.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_ON_OnPush_1, false ) );
    POWER_OFF.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_OFF_OnPush_2, false ) );
    for( uint i = 0; i < 16; i++ )
        STORE_PRESET[i+1].OnDigitalChange.Add( new InputChangeHandlerWrapper( STORE_PRESET_OnChange_3, false ) );
        
    for( uint i = 0; i < 16; i++ )
        RECALL_PRESET[i+1].OnDigitalChange.Add( new InputChangeHandlerWrapper( RECALL_PRESET_OnChange_4, false ) );
        
    for( uint i = 0; i < 4; i++ )
        OUTPUT[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( OUTPUT_OnChange_5, false ) );
        
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BG_UHD_44M ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint RX_MATRIX__AnalogSerialInput__ = 0;
const uint LOGIN_DRIVER__DigitalInput__ = 0;
const uint POWER_ON__DigitalInput__ = 1;
const uint POWER_OFF__DigitalInput__ = 2;
const uint STORE_PRESET__DigitalInput__ = 3;
const uint RECALL_PRESET__DigitalInput__ = 19;
const uint OUTPUT__AnalogSerialInput__ = 1;
const uint TX_MATRIX__AnalogSerialOutput__ = 0;
const uint USERNAME__Parameter__ = 10;
const uint PASSWORD__Parameter__ = 11;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
